Loading...
Searching...
No Matches
mpicommunication.hh File Reference
Common » Parallel Communication

Implements an utility class that provides MPI's collective communication methods. More...

`#include <algorithm>`
`#include <functional>`
`#include <memory>`
`#include <mpi.h>`
`#include <dune/common/binaryfunctions.hh>`
`#include <dune/common/exceptions.hh>`
`#include <dune/common/parallel/communication.hh>`
`#include <dune/common/parallel/mpitraits.hh>`
`#include <dune/common/parallel/mpifuture.hh>`
`#include <dune/common/parallel/mpidata.hh>`

Go to the source code of this file.

## Classes

class | Dune::Generic_MPI_Op< Type, BinaryFunction, Enable >
class | Dune::Communication< MPI_Comm >
| Specialization of Communication for MPI. More...

## Namespaces

namespace | Dune
| Dune namespace

## Macros

#define | ComposeMPIOp(func, op)

## Functions

| Dune::ComposeMPIOp (std::plus, MPI_SUM)
| Dune::ComposeMPIOp (std::multiplies, MPI_PROD)
| Dune::ComposeMPIOp (Min, MPI_MIN)
| Dune::ComposeMPIOp (Max, MPI_MAX)

## Variables

template<typename Type, typename BinaryFunction, typename Enable>
std::unique_ptr< MPI_Op > | Dune::Generic_MPI_Op< Type, BinaryFunction, Enable >::op

## Detailed Description

Implements an utility class that provides MPI's collective communication methods.

## Macro Definition Documentation

## ComposeMPIOp

#define ComposeMPIOp | ( |  | func,
|  |  | op )

Value:
template<class T, class S> \
class Generic_MPI_Op<T, func<S>, std::enable_if_t<MPITraits<S>::is_intrinsic> >{ \
public: \
static MPI_Op get(){ \
return op; \
} \
private: \
Generic_MPI_Op () {} \
Generic_MPI_Op (const Generic_MPI_Op & ) {} \
}
std
STL namespace.